package com.skybeacon.sdk;

/**
 * 烧录状态回调函数
 * 
 * @author frank
 * 
 */
public interface OADProcessCallback {

	/**
	 * 烧录情况
	 * 
	 * @param fileSize
	 * @param writeSize
	 * @param percent
	 *            百分比％
	 */
	public void onProcessCallback(long fileSize, long writeSize, int percent);

	/**
	 * 烧录成功回调
	 * 
	 * @param fileSize
	 * @param writeSize
	 */
	public void onOADSuccess(long fileSize, long writeSize);

	/**
	 * 烧录失败回调
	 * 
	 * @param fileSize
	 * @param writeSize
	 * @param errorCode
	 * @param errorStr
	 */
	public void onOADFailed(long fileSize, long writeSize, int errorCode, String errorMsg);

	/**
	 * 切换回调
	 * 
	 * @param isInOADMode
	 * @param isSwitchSuccess
	 */
	public void onImageSwitch(boolean isInOADMode, boolean isSwitchSuccess, int errorCode, String errorMsg);
}
